wayland::keyboard_t(3)

NAME
wayland::keyboard_t - keyboard input device

SYNOPSIS

#include <wayland-client-protocol.hpp>

Inherits wayland::proxy_t.

  Public Types

enum class wrapper_type { standard, display, foreign, proxy_wrapper }

  Public Member Functions

void release ()
release the keyboard object
bool can_release () const
Check whether the release function is available with the currently bound version of the protocol.
std::function< void(keyboard_keymap_format, int, uint32_t)> & on_keymap ()
keyboard mapping
std::function< void(uint32_t, surface_t, array_t)> & on_enter ()
enter event
std::function< void(uint32_t, surface_t)> & on_leave ()
leave event
std::function< void(uint32_t, uint32_t, uint32_t, keyboard_key_state)> & on_key ()
key event
std::function< void(uint32_t, uint32_t, uint32_t, uint32_t, uint32_t)> & on_modifiers ()
modifier and group state
std::function< void(int32_t, int32_t)> & on_repeat_info ()
repeat rate and delay
uint32_t get_id () const
Get the id of a proxy object.
std::string get_class () const
Get the interface name (class) of a proxy object.
uint32_t get_version () const
Get the protocol object version of a proxy object.
wrapper_type get_wrapper_type () const
Get the type of a proxy object.
void set_queue (event_queue_t queue)
Assign a proxy to an event queue.
wl_proxy * c_ptr () const
Get a pointer to the underlying C struct.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
operator bool () const
Check whether this wrapper actually wraps an object.
bool operator== (const proxy_t &right) const
Check whether two wrappers refer to the same object.
bool operator!= (const proxy_t &right) const
Check whether two wrappers refer to different objects.
void proxy_release ()
Release the wrapped object (if any), making this an empty wrapper.

  Static Public Attributes

static constexpr std::uint32_t release_since_version = 3
Minimum protocol version required for the release function.

Detailed Description

keyboard input device

The wl_keyboard interface represents one or more keyboards associated with a seat.

Examples
egl.cpp, and proxy_wrapper.cpp.

Definition at line 3117 of file wayland-client-protocol.hpp.

Member Enumeration Documentation

  enum class wayland::proxy_t::wrapper_type [strong], [inherited]
Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator

standard
    C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.

display
    C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign
    C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper
    C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 117 of file wayland-client.hpp.

Member Function Documentation

  wl_proxy * wayland::proxy_t::c_ptr () const [inherited]

Get a pointer to the underlying C struct.

Returns
    The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

  bool keyboard_t::can_release () const

Check whether the release function is available with the currently bound version of the protocol.

Definition at line 3124 of file wayland-client-protocol.cpp.

  std::string wayland::proxy_t::get_class () const [inherited]

Get the interface name (class) of a proxy object.

Returns
    The interface name of the object associated with the proxy

  uint32_t wayland::proxy_t::get_id () const [inherited]

Get the id of a proxy object.

Returns
    The id the object associated with the proxy

  uint32_t wayland::proxy_t::get_version () const [inherited]

Get the protocol object version of a proxy object. Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
    The protocol object version of the proxy or 0

  wrapper_type wayland::proxy_t::get_wrapper_type () const [inline], [inherited]

Get the type of a proxy object.

Definition at line 303 of file wayland-client.hpp.

  std::function< void(uint32_t, surface_t, array_t)> & keyboard_t::on_enter ()

enter event

Parameters
    serial serial number of the enter event
    surface surface gaining keyboard focus
    keys the currently pressed keys

Notification that this seat's keyboard focus is on a certain surface.

The compositor must send the wl_keyboard.modifiers event after this event.

Definition at line 3135 of file wayland-client-protocol.cpp.

  std::function< void(uint32_t, uint32_t, uint32_t, keyboard_key_state)> & keyboard_t::on_key ()

key event

Parameters
    serial serial number of the key event
    time timestamp with millisecond granularity
    key key that produced the event
    state physical state of the key

A key was pressed or released. The time argument is a timestamp with millisecond granularity, with an undefined base.

The key is a platform-specific key code that can be interpreted by feeding it to the keyboard mapping (see the keymap event).

If this event produces a change in modifiers, then the resulting wl_keyboard.modifiers event must be sent after this event.

Definition at line 3145 of file wayland-client-protocol.cpp.

  std::function< void(keyboard_keymap_format, int, uint32_t)> & keyboard_t::on_keymap ()

keyboard mapping

Parameters
    format keymap format
    fd keymap file descriptor
    size keymap size, in bytes

This event provides a file descriptor to the client which can be memory-mapped in read-only mode to provide a keyboard mapping description.

From version 7 onwards, the fd must be mapped with MAP_PRIVATE by the recipient, as MAP_SHARED may fail.

Examples
proxy_wrapper.cpp.

Definition at line 3130 of file wayland-client-protocol.cpp.

  std::function< void(uint32_t, surface_t)> & keyboard_t::on_leave ()

leave event

Parameters
    serial serial number of the leave event
    surface surface that lost keyboard focus

Notification that this seat's keyboard focus is no longer on a certain surface.

The leave notification is sent before the enter notification for the new focus.

After this event client must assume that all keys, including modifiers, are lifted and also it must stop key repeating if there's some going on.

Definition at line 3140 of file wayland-client-protocol.cpp.

  std::function< void(uint32_t, uint32_t, uint32_t, uint32_t, uint32_t)> & keyboard_t::on_modifiers ()

modifier and group state

Parameters
    serial serial number of the modifiers event
    mods_depressed depressed modifiers
    mods_latched latched modifiers
    mods_locked locked modifiers
    group keyboard layout

Notifies clients that the modifier and/or group state has changed, and it should update its local state.

Definition at line 3150 of file wayland-client-protocol.cpp.

  std::function< void(int32_t, int32_t)> & keyboard_t::on_repeat_info ()

repeat rate and delay

Parameters
    rate the rate of repeating keys in characters per second
    delay delay in milliseconds since key down until repeating starts

Informs the client about the keyboard's repeat rate and delay.

This event is sent as soon as the wl_keyboard object has been created, and is guaranteed to be received by the client before any key press event.

Negative values for either rate or delay are illegal. A rate of zero will disable any repeating (regardless of the value of delay).

This event can be sent later on as well with a new value if necessary, so clients should continue listening for the event past the creation of wl_keyboard.

Definition at line 3155 of file wayland-client-protocol.cpp.

  wayland::proxy_t::operator bool () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  bool wayland::proxy_t::operator!= (const proxy_t & right) const [inherited]

Check whether two wrappers refer to different objects.

  bool wayland::proxy_t::operator== (const proxy_t & right) const [inherited]

Check whether two wrappers refer to the same object.

  bool wayland::proxy_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void wayland::proxy_t::proxy_release () [inherited]

Release the wrapped object (if any), making this an empty wrapper. Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
foreign_display.cpp.

  void keyboard_t::release ()

release the keyboard object

Definition at line 3119 of file wayland-client-protocol.cpp.

  void wayland::proxy_t::set_queue (event_queue_t queue) [inherited]

Assign a proxy to an event queue.

Parameters
    queue The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
proxy_wrapper.cpp.

Member Data Documentation

  std::uint32_t wayland::keyboard_t::release_since_version = 3 [static], [constexpr]

Minimum protocol version required for the release function.

Definition at line 3152 of file wayland-client-protocol.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.